import { ItemStack } from "@minecraft/server";

export function dropItem(source, item, amount) {
    if (amount > 0) {
        const dimension = source.dimension;
        const location = source.location;
        const itemToDrop = new ItemStack(item, amount);

        if (itemToDrop !== undefined) {
            dimension.spawnItem(itemToDrop, location);
        }
    }
};

export function decreaseDurability(player, item, amount) {
    if (amount > 0) {
        const durability = item.getComponent("durability");
        const unbreakingLevel = item.getComponent('enchantable')?.getEnchantment('unbreaking')?.level;

        if (durability && player?.getGameMode() !== "creative") {
            if ((durability.maxDurability-durability.damage) > amount) {
                if (unbreakingLevel > 0) {
                    if (Math.floor(Math.random() * (unbreakingLevel + 1)) == 0) {
                        durability.damage += amount;
                        player.getComponent("equippable")?.setEquipment("Mainhand", item);
                    }
                } else {
                    durability.damage += amount;
                    player.getComponent("equippable")?.setEquipment("Mainhand", item);
                }
            } else {
                player.playSound('random.break');
                player.getComponent("equippable")?.setEquipment("Mainhand", undefined);
            }
        }
    }
};